import multiprocessing
from drive_avhrr import run_one_year, make_one_iff

N_WORKERS = 64

def call_make_one_iff(make_one_iff_dict):
    """Wrapper function to call make_one_iff with a dict of params."""
    d = make_one_iff_dict
    make_one_iff(d['time'], d['satid'], d['hirs_dir'], d['avhrr_dir'], zara=True)

if __name__ == "__main__":
    """Run one year using N_WORKERS workers."""
    (time_set, satid, hirs_dir, avhrr_dir) = run_one_year(2009, 18)

    make_one_iff_jobs = []
    for time in time_set:
        make_one_iff_dict = dict()
        make_one_iff_dict['time'] = time
        make_one_iff_dict['satid'] = satid
        make_one_iff_dict['hirs_dir'] = hirs_dir
        make_one_iff_dict['avhrr_dir'] = avhrr_dir
        make_one_iff_jobs.append(make_one_iff_dict)

    # mjh 2014/08/21 this could be multi-threaded instead of multi-processed
    # now that we are just calling out to the shell for each job, but I don't
    # feel like refactoring for multi-threaded and this should be fine for now.
    pool = multiprocessing.Pool(N_WORKERS)
    pool.map(call_make_one_iff, make_one_iff_jobs)
    #pool.map(call_make_one_iff, make_one_iff_jobs[0:64])
